SystemOrganization addCategory: #Kozen!

Object subclass: #ARTodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARTodo commentStamp: 'sd 1/7/2012 16:30' prior: 0!
to do
	- add long cv link
	- manage lists
	- convert all web site
	- manage news: show two from a list and on demand all
	- parse information from file instead of typing it in Smalltalk
	!

Object subclass: #Citeseer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!Citeseer commentStamp: 'DamienCassou 1/6/2012 18:39' prior: 0!
Get the rank of someone in the Citeseer author's citation ranking (http://citeseerx.ist.psu.edu/stats/authors?all=true).

For example:

Citeseer rankOf: 'S. Ducasse'!

!Citeseer class methodsFor: 'public' stamp: 'DamienCassou 1/6/2012 18:37'!
rankOf: aName
	"self rankOf: 'S. Ducasse'"
	^ self new rankOf: aName! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:23'!
getCiteseerPage
	^ ZnHttpClient new
		url: 'http://citeseerx.ist.psu.edu/stats/authors';
		parameterAt: 'all' put: 'true';
		get! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:36'!
getRankFrom: page stoppingAt: aString
	| count |
	count := 0.
	page
		regex: '<li>[[:space:]]*<span class="authors">[^>]+>([^<]+)'
		matchesDo: [:match | (match matchesRegex: ('.*', aString, '$'))
								ifTrue: [^ count + 1]
								ifFalse: [count := count + 1]].
	^ Error signal: aString, ' not found in page'! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:34'!
rankOf: aName
	| content rank |
	content := self getCiteseerPage.
	rank := self getRankFrom: content stoppingAt: aName.
	^ rank ! !

Object subclass: #KZObject
	instanceVariableNames: 'value siteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZObject subclass: #KZImage
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZImage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/3/2012 11:20'!
accept: aVisitor

	aVisitor visitImage: self.
! !

!KZImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image
	^ image! !

!KZImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image: anObject
	image := anObject! !

KZImage subclass: #KZLinkedImage
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZLinkedImage methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:51'!
accept: aVisitor

	aVisitor visitLinkedImage: self! !

!KZLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link
	^ link! !

!KZLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link: anObject
	link := anObject! !

KZObject subclass: #KZItem
	instanceVariableNames: 'name link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZItem subclass: #KZBlockItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZBlockItem commentStamp: 'StephaneDucasse 1/3/2012 23:00' prior: 0!
ARBlockItem is an item of a floating block. For example like on the right of my web page.!

!KZBlockItem methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 23:04'!
accept: aVisitor

	aVisitor visitRightBlockItem: self.
! !

!KZItem methodsFor: 'visit' stamp: 'sd 1/8/2012 22:15'!
accept: aVisitor

	aVisitor visitItem: self.! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link
	
	^ link! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link: aName

	link := aName! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name

	^ name! !

!KZItem methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name:  aString

	name := aString! !

KZItem subclass: #KZMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenuItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitMenuItem: self.
! !

KZObject subclass: #KZList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZList subclass: #KZDivBlock
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZDivBlock commentStamp: 'StephaneDucasse 1/5/2012 22:15' prior: 0!
<div id="header">
	attribute = id 
	value = header
	
	and nested components
	
!

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 11:19'!
accept: aVisitor

	aVisitor visitDivBlock: self.
! !

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute
	^ attribute! !

!KZDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute: aString
	
	attribute := aString! !

!KZList methodsFor: 'visit' stamp: 'sd 1/8/2012 22:30'!
accept: aVisitor

	aVisitor visitItemList: self! !

!KZList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
addElement: anElement

	elements add: anElement! !

!KZList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
elements

	^ elements! !

!KZList methodsFor: 'initialize' stamp: 'StephaneDucasse 1/3/2012 22:46'!
initialize

	super initialize.
	elements := OrderedCollection new.! !

KZList subclass: #KZMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZMenu methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:56'!
accept: aVisitor

	aVisitor visitMenu: self.
! !

KZList subclass: #KZResearchTopic
	instanceVariableNames: 'text bibItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

KZList subclass: #KZRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZRightBlock methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:49'!
accept: aVisitor

	aVisitor visitRightBlock: self.! !

KZList subclass: #KZSection
	instanceVariableNames: 'levelNumber title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:18'!
accept: aVisitor

	aVisitor visitSection: self! !

!KZSection methodsFor: 'initialize' stamp: 'sd 1/7/2012 20:53'!
initialize

	super initialize.
	levelNumber := '2'.! !

!KZSection methodsFor: 'accessing' stamp: 'sd 1/7/2012 20:53'!
levelDigitString

	^ levelNumber! !

!KZSection methodsFor: 'accessing' stamp: 'sd 1/7/2012 20:59'!
levelDigitString: aString
	"'2' for h2, '3' for h3...."

	levelNumber := aString! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text
	^ text! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text: anObject
	text := anObject! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title
	^ title! !

!KZSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title: anObject
	title := anObject! !

!KZObject methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:47'!
accept: aVisitor
	! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId
	^ siteId! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId: anId
	"anId should uniquely identify the receiver"
	siteId := anId! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:09'!
value
	^ value! !

!KZObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:10'!
value: aString
	value := aString! !

KZObject subclass: #KZPage
	instanceVariableNames: 'title elements head name main site filename cssFile headerSiteTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZPage commentStamp: 'StephaneDucasse 1/18/2012 21:24' prior: 0!
I'm a page and as such I contain elements and I'm saved in a file.!

!KZPage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitPage: self.
! !

!KZPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/2/2012 21:54'!
addElement: anElement

	elements add: anElement.! !

!KZPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/6/2012 14:34'!
addElementInMain: anElement

	main addElement: anElement.! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:49'!
cssFile
	^cssFile! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:49'!
cssFile: aString
	
	cssFile := aString! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/19/2012 21:41'!
defaultCSSFile
	^ 'CSS/stef.css'! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/2/2012 22:39'!
defaultName

	^ 'Home'! !

!KZPage methodsFor: 'default' stamp: 'StephaneDucasse 1/19/2012 21:55'!
defaultTitle

	^ 'The title can also give some information about you' ! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:54'!
elements

	^ elements! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/8/2012 21:29'!
filename
	
	|fn|
	filename isNil 
		ifTrue: [fn := name]
		ifFalse: [fn := filename].
	^ fn, '.html'.
	! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/8/2012 21:24'!
filename: aName
	
	filename := aName! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:54'!
head

	^ '<head>
		<link rel="stylesheet" href="' , self cssFile
		,
			'"/>
		<title>' , self defaultTitle
		,
			'</title>
   </head>'! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:26'!
headerPageTitle

	^ self name
! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:58'!
headerSiteTitle
	"the title inside the page"
	
	^ headerSiteTitle! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:58'!
headerSiteTitle: aString
	"the title inside the page"
	
	headerSiteTitle := aString! !

!KZPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/19/2012 21:54'!
initialize

	super initialize.
	elements := OrderedCollection new.
	title := self defaultTitle.
	name := self defaultName.
	cssFile := self defaultCSSFile.
	main := KZDivBlock new attribute: 'id' ; value: 'mainContent'.! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 14:27'!
main
	"describes the main part of the body - related to css may be we should change that but 
	menu should be out and block and section nested in."
	
	^ main! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:52'!
metaHead

	^ '<?xml version="1.0" encoding="ISO-8859-1"?>
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">'! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:45'!
name 
	"For example the welcomePage can be called Home "
	^ name! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name: aString
	name := aString! !

!KZPage methodsFor: 'printing' stamp: 'sd 1/8/2012 21:04'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	aStream nextPutAll: self name. ! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:19'!
site

	^ site! !

!KZPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:20'!
site:  aSite

	site := aSite! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:41'!
title

	^ title ! !

!KZPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 21:40'!
title: aString

	title := aString! !

Object subclass: #KZSite
	instanceVariableNames: 'elements pages folder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:03'!
addPage: aPage

	pages add: aPage! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/18/2012 21:19'!
declare: anElement withId: anID
	"Declare the element with a given id so that we can link back to it"
	
	elements at: anID put: anElement! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/18/2012 21:20'!
declarePage: aPage withId: anID
	"Declare a page with a given id for future reference. A page is also added to the site web page."
	elements at: anID put: aPage.
	aPage site: self.
	pages add: aPage.! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/19/2012 21:29'!
generate
	"self new generate"
	
	| visitor |
	visitor := self visitorClass new.
	visitor visitSite: self site.
	! !

!KZSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:02'!
initialize

	super initialize.
	elements := Dictionary new.
	pages := OrderedCollection new.! !

!KZSite methodsFor: 'operations' stamp: 'sd 1/6/2012 22:25'!
pages
	^ pages! !

!KZSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/19/2012 21:29'!
visitorClass

	^  KZVisitor ! !

KZSite subclass: #KzMenuInfoBodySite
	instanceVariableNames: 'bibBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KzMenuInfoBodySite class methodsFor: 'initialization' stamp: 'StephaneDucasse 1/18/2012 21:25'!
generate
	"self generate"
	self new generate! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 08:14'!
block
	| block |
	block := KZRightBlock new.
	self buildBlockBodyOn: block.
	self declare: block withId: #block.
	^ block! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/18/2012 21:08'!
buildBlockBodyOn: block
	block addElement: self imageItem.
	block addElement: self inriaBlockItem.
	block addElement: self rmodBlockItem.
	block addElement: self mailToBlockItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/18/2012 21:05'!
buildMenuBodyOn: menu
	"Subclasses can change the menu items simply by changing this method"

	menu addElement: self homeMenuItem.
	menu addElement: self pharoMenuItem.
	menu addElement: self coordinatesMenuItem! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 21:24'!
buildOtherPages

	! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:13'!
buildWelcomePageSectionsOn: welcomePage
	welcomePage addElementInMain: self sectionCurrentJob.
	welcomePage addElementInMain: self sectionNews.	
	! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 08:13'!
coordinatesMenuItem
	^ KZMenuItem new
		name: 'Coordinates';
		link: 'Coordinates.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 21:48'!
cssFile
	^ 'CSS/stef.css'! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 09:02'!
currentJobText

	^ 'I''m ZZZ and I have a lot of fun doing KKK .' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:34'!
currentSectionTitle
	^ 'Current Situation'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 21:57'!
defineInformationOfPage: welcomePage
	welcomePage title: self title.
	welcomePage cssFile: self cssFile.
	welcomePage headerSiteTitle: self headerSiteTitle.
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 21:57'!
headerSiteTitle

	^ 'Ze great title'
	! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 08:13'!
homeMenuItem
	^ KZMenuItem new
		name: 'Home';
		link: 'index.html';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/18/2012 21:32'!
imageItem
	^ KZImage new
		image: self imageName;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/18/2012 21:18'!
imageName
	^ 'PictureToBeDisplayedIn128Pixels.jpg'! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/19/2012 08:16'!
inriaBlockItem
	^ KZBlockItem new
		name: 'INRIA';
		link: 'http://www.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/18/2012 21:12'!
mailText
	^ 'XXXX(@At@)YYYY.HHH'! !

!KzMenuInfoBodySite methodsFor: 'mail' stamp: 'StephaneDucasse 1/19/2012 08:13'!
mailToBlockItem
	^ KZBlockItem new
		name: self mailText;
		link: self mailtoString;
		yourself! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/18/2012 21:13'!
mailtoString
	^ 'mailto:real.address@foo.bar'! !

!KzMenuInfoBodySite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/19/2012 08:15'!
menu
	| menu |
	menu := KZMenu new.
	self buildMenuBodyOn: menu.
	self declare: menu withId: #menu.
	^ menu! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:37'!
newsSectionTitle
	^ 'News'! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 09:39'!
newsText

	^ '<div class="itemizedlist"> 
      <ul type="disc"> 
		<li>I attended <a href="http://www.esug.org/wiki/pier/Conferences/2011"> ESUG 2011</a>. </li>
	 	<li><a href="http://www.pharo-project.org/">Pharo</a> is cool!!</li>
	
	  </ul>
    </div>'! !

!KzMenuInfoBodySite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 08:13'!
pharoMenuItem
	^ KZMenuItem new
		name: 'Pharo';
		link: 'http://www.pharo-project.org';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'block' stamp: 'StephaneDucasse 1/19/2012 08:16'!
rmodBlockItem
	^ KZBlockItem new
		name: 'RMOD';
		link: 'http://rmod.lille.inria.fr/';
		yourself! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 09:34'!
sectionCurrentJob
	| section |
	section := KZSection new
		title: self currentSectionTitle;
		text: self currentJobText.
	self declare: section withId: #secCurrentJob.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 09:37'!
sectionNews
	| section |
	section := KZSection new
		title: self newsSectionTitle;
		text: self newsText.
	self declare: section withId: #secNews.
	^ section! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:12'!
site
	"self site"
	
	self welcomePage.
	self buildOtherPages.
	
	^ self.
	! !

!KzMenuInfoBodySite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/19/2012 21:47'!
title 

	^ 'Dr. St&eacute;phane Ducasse' ! !

!KzMenuInfoBodySite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/19/2012 21:24'!
welcomeName
	^ 'Home'! !

!KzMenuInfoBodySite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 21:51'!
welcomePage
	| welcomePage |
	welcomePage := KZPage new.
	welcomePage name: self welcomeName.
	welcomePage filename: 'index'.
	self defineInformationOfPage: welcomePage.
	self declarePage: welcomePage withId: #welcomePage.
	welcomePage addElement: self menu.
	welcomePage addElementInMain: self block.
	self buildWelcomePageSectionsOn: welcomePage.
	^ welcomePage! !

KzMenuInfoBodySite subclass: #SimonSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!SimonSite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:25'!
buildMenuBodyOn: menu
	"Subclasses can change the menu items simply by changing this method"

	menu addElement: self homeMenuItem.
	menu addElement: self pharoMenuItem.
	menu addElement: self coordinatesMenuItem! !

!SimonSite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:25'!
buildWelcomePageSectionsOn: welcomePage
	welcomePage addElementInMain: self sectionCurrentJob.
	welcomePage addElementInMain: self sectionNews.	
	! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:21'!
cssFile
	^ 'CSS/stef.css'! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:22'!
currentJobText

	^ 'I''m post doc in the RMOD Team. I worked on Component Identification using dynamic information.' ! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:23'!
headerSiteTitle

	^ 'Simon Allier'
	! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:23'!
mailText
	^ 'Simon.Allier(@At@)inria.fr'! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:10'!
mailtoString
	^ 'mailto:simon.allier@inria.fr'! !

!SimonSite methodsFor: 'custom-points' stamp: 'StephaneDucasse 1/23/2012 14:26'!
newsText

	^ '<div class="itemizedlist"> 
      <ul type="disc"> 
		<li>My CASCON paper got awarded best student paper 2009.</li>
		<li>I ''m working . </li>
	  </ul>
    </div>'! !

!SimonSite methodsFor: 'custom-points-who' stamp: 'StephaneDucasse 1/23/2012 14:24'!
title 

	^  'Dr. Simon Allier'! !

KzMenuInfoBodySite subclass: #StefSite
	instanceVariableNames: ''
	classVariableNames: 'CachedSiteSeer'
	poolDictionaries: ''
	category: 'Kozen'!

StefSite class
	instanceVariableNames: 'site menu page main'!

!StefSite commentStamp: 'StephaneDucasse 1/18/2012 21:26' prior: 0!
StefSite generate!

StefSite class
	instanceVariableNames: 'site menu page main'!

!StefSite class methodsFor: 'initialization' stamp: 'sd 1/7/2012 18:30'!
initialize

	CachedSiteSeer := true.! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/18/2012 22:11'!
addLanguageNavigation

	| list |
	list := KZList new. 
	self languageSubTopics do: [:each |
		list addElement: (KZItem new name: each second; link: each first, '.html')
		].
	^ list! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/18/2012 22:11'!
addSoftwareEvolutionNavigation

	| list |
	list := KZList new. 
	self evolutionSubTopics do: [:each |
		list addElement: (KZItem new name: each second; link: each first, '.html')
		].
	^ list! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/8/2012 21:28'!
awardText

	^ '	<div class="itemizedlist"> 
      <ul type="disc">
	<li>Distinguished Visiting Fellowship Award of the Royal Academy of Engineering (2011).</li>
	<li>Veronica Uquillas Gomez won the Benevol most promising young research Award (2011).</li>
	<li>Mariano Martinez-Peck and Martin Diaz won for Fuel the 2011 ESUG Technology Award. </li>
	<li> <a href="http://books.seaside.st/">Dynamic web development with Seaside</a>: Our new free open-source Seaside book won the ESUG member 2010 best book Award.</li>
	  <li> Michele Lanza (2003) and Alexandre Bergel (2006) PhD theses won the <a href="http://www.denert-stiftung.de/">Ernest Denert foundation for Software Engineering</a> Award.</li>
	  
	  <li> <a href="http://rmod.lille.inria.fr/botsinc/pier">Learning Programming with Robots</a> received the Award of PCPlus magazine of September 2005 and the Bitwise Recommended Award in February 2006.
	  </ul>'
! !

!StefSite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/23/2012 14:18'!
bibBuilder

	^ bibBuilder! !

!StefSite methodsFor: 'accessing' stamp: 'StephaneDucasse 1/23/2012 14:18'!
bibBuilder: aBuilder

	bibBuilder := aBuilder! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:26'!
booksMenuItem
	^ KZMenuItem new
		name: 'Books';
		link: 'Books.html';
		yourself! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:27'!
buildMenuBodyOn: menu
	menu addElement: self homeMenuItem.
	menu addElement: self pharoMenuItem.
	menu addElement: self publicationMenuItem.
	menu addElement: self booksMenuItem.
	menu addElement: self freeSmalltalkBooksMenuItem.
	menu addElement: self resourcesMenuItem.
	menu addElement: self teachingMenuItem.
	menu addElement: self coordinatesMenuItem! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:17'!
buildWelcomePageSectionsOn: welcomePage
	welcomePage addElementInMain: self sectionCurrentJob.
	welcomePage addElementInMain: self sectionAwardsAndIndexes.
	welcomePage addElementInMain: self sectionNews.
	welcomePage addElementInMain: self sectionResearch.
	welcomePage addElementInMain: self sectionSoftwareEvolution.
	welcomePage addElementInMain: self addSoftwareEvolutionNavigation.
	welcomePage addElementInMain: self sectionLanguageDesign.
	welcomePage addElementInMain: self addLanguageNavigation.
	welcomePage addElementInMain: self sectionService! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/7/2012 18:32'!
citeseerText
	
	|cite |
	cite := CachedSiteSeer 
				ifTrue: [self defaultSiteSeer]
				ifFalse: [(Citeseer rankOf: 'S. Ducasse')].
	^ 'According to <a href="http://citeseerx.ist.psu.edu/stats/authors">CiteSeer</a>, I''m at rank ', cite asString, ' of most cited computer scientists.'.  ! !

!StefSite methodsFor: 'utils' stamp: 'sd 1/8/2012 22:09'!
createResearchSubTopicPages

	self evolutionSubTopics
		do: [ :each | 
			self
				createSubTopic: each first
				title: each second
				text: each third
				bibTag: each fourth.
			each first ].
		
	self languageSubTopics
		do: [ :each | 
			self
				createSubTopic: each first
				title: each second
				text: each third
				bibTag: each fourth.
			each first ]! !

!StefSite methodsFor: 'utils' stamp: 'StephaneDucasse 1/19/2012 08:14'!
createSubTopic: file title: name text: text bibTag: bibTag
	| page |
	page := KZPage new.
	page name: 'Research Topics'.
	page filename: file.
	self declarePage: page withId: (self subtopicKey: file).
	page addElement: self menu.
	page
		addElementInMain:
			(KZSection new
				title: name;
				levelDigitString: '3';
				text: text;
				yourself).
	page addElementInMain: (bibBuilder collectionBasedOnKozenTag: bibTag).
	^ page! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 15:40'!
currentJobText

	^ 'Since June 2011, I''m scientific officer of  <a HREF="http://www.inria.fr/centre-de-recherche-inria/lille-nord-europe">INRIA Lille Nord Europe research center</a>. Since September 2007, I''m research director at <a HREF="http://www.inria.fr">INRIA Lille</a> leading the <a href="http://rmod.lille.inria.fr">RMoD Team</a>. During 10 years, I co-directed with Oscar Nierstrasz the <A HREF="http://www.iam.unibe.ch/~scg"> Software Composition Group</a>. I was the leader of the <A HREF="http://www.iam.unibe.ch/~scg/Research/Recast/index.html">RECAST Project</a>.  I''m the president of <a HREF="http://www.esug.org/">ESUG</a>. Here is a short <a HREF="2011-CV.pdf">CV</a>.' ! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/19/2012 09:33'!
currentSectionTitle
	^ 'Current responsibilities'! !

!StefSite methodsFor: 'initialize' stamp: 'sd 1/7/2012 18:28'!
defaultSiteSeer

	^ 3194! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/9/2012 19:06'!
evolutionSubTopics
	^ #(#('Modularisation' 'Software remodularisation' 
		'We explored various techniques to support software remodularisation and restructuring at different levels of granularity and with different objectives.'
		 '*kzRemodularisation*') 
	
		#('Visualization' 'Software Visualization' 
		'We explored how program visualization can support software understanding.  We work at different level: system, class, packages, but also using different information: structure, runtime, references. Quite exciting topics.' 
		'*kzVisualization*')
		
		#('MetaModeling' 'Meta Modeling' 
		'' 
		'*kzMeta*')
		
		#('Merging' 'Supporting Merging' 
		''
		 '*kzMerging*') 
		
		#('Cycle' 'Cycle and Layer Identification' 
		'' 
		'*kzCycle*')
		
		#('IDE' 'Integrated Software Developments' 
		'We explored difference facets of IDEs: from frameworks to build them to dynamic information to use them.' 
		'*kzIDE*')
		
		#('Metric' 'Software Metrics and Quality Models' 
		'We applied and evaluate software metrics as well as quality models. We worked with PSA and AirFrance in the context of the Squale FUI project. We collaborated with Qualixo. ' 
		'*kzMetric')
		
		#('Dynamic' 'Dynamic information and feature analysis' 
		'' 
		'*kzDynamicInformation*')
		
		#('Duplication' 'Identification of Duplicated Code' 
		'' 
		'*kzDuplication*')
		
		#('Tools' 'Reengineering Tools, Interexchange, and Infrastructure' 
		'' 
		'*kzTools*')
		
		#('Checking' 'Checking ' 
		'' 
		'*kzChecking*')
		
		#('Archi' 'Architecture Extraction and Validation ' 
		'' 
		'*kzArchi*')
		
		#('Patterns' 'Evolution, Reengineering Challenges and Patterns' 
		'' 
		'*kzPattern*')
		
		#('History' 'History-based Analyses and Mining Repositories' 
		'' 
		'*kzHistory*')
		
		)! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:26'!
freeSmalltalkBooksMenuItem
	^ KZMenuItem new
		name: 'Free Smalltalk Books';
		link: 'FreeBooks.html';
		yourself! !

!StefSite methodsFor: 'who' stamp: 'StephaneDucasse 1/19/2012 21:58'!
headerSiteTitle
	"the title inside the page"
	
	^ 'St&eacute;phane Ducasse'! !

!StefSite methodsFor: 'block' stamp: 'StephaneDucasse 1/18/2012 20:49'!
imageName
	^ 'StefFingerOnNose128.jpg'! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 10:09'!
indexesText

	^ 'According to google scholar my h-index is 41 and my g-index is 70 - Maximum Cites: 343.'
! !

!StefSite methodsFor: 'initialize' stamp: 'StephaneDucasse 1/23/2012 14:17'!
initialize
	super initialize.
	bibBuilder := KZBibCollectionBuilder new author: '*Ducasse*'; loadBib: 'rmod.bib'.! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 10:06'!
keywordsText

	^ 'Software Engineering, Object-Oriented Programming, Language Design, Reengineering, Reverse Engineering, Program Understanding, Reflective Programming, Dynamically typed languages, Meta-Programming, MOP, Aspect-Oriented Programming, Modules, Frameworks, Design Patterns, Teaching OO, Traits, Classboxes, Scheme, Smalltalk, Java, C#.'
! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/10/2012 15:55'!
languageSubTopics
	^ #(
	
		#('Clutter' 'Clutter collector'
			'Often objects are referenced but not used anymore. We are working on a clutter mechanism that acts as a memory manager to reduce the memory footprint of application and use secondary memory as a paging mechanism.'
			'*kzClutter*')
			
			
		#('Trait' 'Traits: Intraclass reuse' 
		'Traits are groups of methods that can be reused orthogonally to inheritance. 
		We defined Traits which allows one to structure classes orthogonally to inheritance and offer a better composition mechanism than mixins. We formalized traits  and identify the problems with their introduction in strongly-typed languages. We proposed analysis to support the identification of traits in existing applications.  We extended traits with the notion of state and visibility. 
		
		 PHP 5.4, PERL-6, Dr-Scheme OO layer, Squeak3.9 and Pharo include traits. Traits influenced Scala (http://scala.epfl.ch/) developed at EPFL. Fortress (a new language for scientific computation developed by G. Steele) is entirely based on a variant of traits (http://labs.oracle.com/projects/plrg/). Several libraries have been developed for Ruby and Javascript. 
Several research teams proposed formal type systems for traits, showing the interest of the scientific community:  S. Drossopoulos, V. Bono/F. Damiano, L. Liquori and J. Reppy/K. Fisher.'
		 '*kzTrait*') 
	
		
		#('Classbox' 'Scoping class extensions: Classboxes' 
		'Some languages such as Objective-C, Ruby, Python, Smalltalk can define methods in package while their classes is defined in other packages. This allows one to build powerful layers and extend classes. But this poses the questions of the semantics of such constructs. Classboxes is an experimental solution that scope them dynamically and propose a flat view of the world from the extending package perspective.' 
		'*kzClassbox*')
		
		#('Modules' 'Software Modules and Aspects' 
		'We worked on classboxes and this led us to think deeply about how names are looked up. We also work on aspects and other modular concerns. I spent a lot of time thinking about a good module system for dynamic languages and I will work on it.' 
		'*kzModule*')
		
		#('Web' 'Dynamic Web Development' 
		'' 
		'*kzWeb*')
		
		#('Reflection' 'Reflective Programming' 
		'' 
		'*kzReflection*')
		
		#('Varia' 'Components, Encapsulation and Others' 
		'' 
		'*kzLanguageDesign*')
		
		)! !

!StefSite methodsFor: 'mail' stamp: 'StephaneDucasse 1/18/2012 21:12'!
mailText
	^ 'StephaneDucasse(@At@)inria.fr'! !

!StefSite methodsFor: 'mail' stamp: 'StephaneDucasse 1/18/2012 21:07'!
mailtoString
	^ 'mailto:stephane.ducasse@inria.fr'! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/7/2012 20:46'!
newsText

	^ '<div class="itemizedlist"> 
      <ul type="disc"> 
		<li>I was general chair of <a href="http://www.esug.org/wiki/pier/Conferences/2011"> ESUG 2011</a>. </li>
		<li>We got a new associated team named Plomo with Pleiad of University of Chile at Santiago.</li>
	  <li>We are setting up an INRIA consortium with industrial partners around <a href="http://www.pharo-project.org">Pharo</a>. Pharo 1.3 is out and 1.4 is in alpha.</li>
	  <li><a href="http://www.pharo-project.org/pharobyexample/">Pharo By Example</a> is free and out (in spanish, french, english and  japanese)!!</li>
	 <li> <a href="http://www.moosetechnology.org">Moose</a>. Moose is a software analysis meta-described platform that allows one to understand and analyze object-oriented applications developed in Smalltalk, Java or C++. Moose 4.3 is out.</li>
	  </ul>
    </div>'! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:26'!
publicationMenuItem
	^ KZMenuItem new
		name: 'Publications';
		link: 'Publications.html';
		yourself! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/7/2012 20:48'!
researchText

	^ '
	My research statement is double: (1) How can we help companies to support the evolution and maintenance of their large applications and (2) how can we improve languages to better support evolution?
	
	'! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:27'!
resourcesMenuItem
	^ KZMenuItem new
		name: 'Downloads/Resources';
		link: 'Resources.html';
		yourself! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:14'!
sectionAwardsAndIndexes

	| section | 
	section := KZSection new title: 'Awards and Indexes'; text: self indexesText , ' ', self citeseerText,  (Character cr asString), self awardText.
	self declare: section withId: #secAwards.
	^ section! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:14'!
sectionLanguageDesign

	| section | 
	section := KZSection new title: 'Language Design'; levelDigitString: '3'; text: 'I''m interested in revisiting foundational bricks of object-oriented languages such as encapsulation, reuse, message passing. Now I start to work on isolation and security in reflective object-oriented languages.'. 
	self declare: section withId: #secLanguageDesign.
	^ section! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:14'!
sectionResearch

	| section | 
	section := KZSection new title: 'Research'; text: self researchText. 
	self declare: section withId: #secResearch.
	^ section! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:14'!
sectionService

	| section | 
	section := KZSection new title: 'Program Committees'; text: self serviceText. 
	self declare: section withId: #secResearch.
	^ section! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/19/2012 08:14'!
sectionSoftwareEvolution

	| section | 
	section := KZSection new title: 'Maintenance and Software Evolution'; levelDigitString: '3'; text: 'I''m interested in all the aspects of software evolution and maintenance of large systems. I consulted for companies. Do not hesitate to contact me. I''m interested in your problems.' ; yourself. 
	self declare: section withId: #secMaintenance.
	^ section! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/10/2012 15:51'!
serviceText

	^ ' Here are some of the international conferences I was PC member. Now with my new responsibilities I decline more often committees participation. 
	<div class="itemizedlist"> 
      <ul type="disc">
	 <li> European Conference on Object-Oriented Programming (ECOOP 05, 07, 10) -- Core A *.</li>
	 <li>International Conference on Software Maintenance (ICSM 05, 06, 07, 08, 10, 11) -- Core A.</li>
	 <li>European Conference on Software Maintenance and Reengineering (CSMR 06, 07, 08).</li>
	 <li>International Conference on Program Comprehension (ICPC 06, 07, 08).</li>
	 <li>International Conference on the Unified Modeling Language (UML 03, 04, Models/UML 05, Models 06, 07, 09, 10) -- Core A.</li>
	 <li>International Dynamic Languages Symposium (DLS 05, 06).</li>
	 <li>International Symposium on Software Variability: a Programmers Perspective (SVPP 08).</li>
	 <li>International Conference on Extreme Programming (XP 00, 01).</li>
	<li> International Conference on Objects, Models, Components, Patterns (TOOLS 2009, 2010, 2011).</li>
	 <li>Working Conference on Reverse Engineering (WCRE 02, 05, 06, 10).</li>
	<li> International  Conference on Software Composition (SC 09).</li>
	</ul>
	</div>
'! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/23/2012 14:12'!
site
	"self site"
	
	self createResearchSubTopicPages.
	self welcomePage.
	self buildOtherPages.
	
	^ self.
	! !

!StefSite methodsFor: 'utils' stamp: 'sd 1/8/2012 21:40'!
subtopicKey: file
	^ ('research' , file) asSymbol! !

!StefSite methodsFor: 'menu' stamp: 'StephaneDucasse 1/19/2012 21:27'!
teachingMenuItem
	^ KZMenuItem new
		name: 'Lectures and Presentations';
		link: 'Teaching.html';
		yourself! !

!StefSite methodsFor: 'who' stamp: 'StephaneDucasse 1/19/2012 21:52'!
title 

	^ 'Dr. St&eacute;phane Ducasse' ! !

Object subclass: #KZVisitor
	instanceVariableNames: 'site stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!KZVisitor commentStamp: 'StephaneDucasse 1/1/2012 22:52' prior: 0!
ARVisitor is a web site visitor. !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:19'!
addComment: aComment
	stream 
		nextPutAll: '    <!!--'; 
		nextPutAll: aComment; 
		nextPutAll: ' -->'.
	! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
bodyEncodings
	^ 'body'! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/2/2012 22:19'!
contents

	^ stream contents! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
cr

	stream nextPut: Character cr! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
div

	self startBalise: 'div'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
divEncodings
	^ 'div'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:37'!
endBalise: aString

	stream nextPut: $< ; nextPut: $/.
	stream nextPutAll: aString.
	stream nextPut: $>. 
	

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
endBaliseCr: aString

	self endBalise: aString.
	self cr.
	

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
endBody

	self endBalise: 'body'.! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:32'!
endDiv

	self endBalise: 'div'! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
ensureAttribute: aKey value: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: aKey value: aTag.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	self cr! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:13'!
ensureBody: aBlock
	self startBalise: self bodyEncodings.
	aBlock cull: stream.
	self endBalise: self bodyEncodings! !

!KZVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/3/2012 11:25'!
ensureDiv: aBlock
	
	self div.
	aBlock value: stream.
	self endDiv! !

!KZVisitor methodsFor: 'operation' stamp: 'sd 1/7/2012 16:36'!
ensureIdValue: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: 'id' value: aTag.
	self cr.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
ensureTag: aString for: aBlock

	self startBalise: aString.
	aBlock value: stream.
	self endBalise: aString! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerEncodings
	^ 'header'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
headerPageTitleEncodings
	^ 'headerPageTitle'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerSideTitleEncodings
	^ 'headerSideTitle'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/6/2012 14:36'!
href: url name: aString

	stream 
		nextPutAll: '<a href="';
		nextPutAll: url;
		nextPutAll: '">';
		nextPutAll: aString;
		nextPutAll: '</a>'! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
mainContentEncodings
	^ 'mainContent'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
menuEncodings
	^ 'menu'! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 21:57'!
newFileFor: aPage
	^ FileStream forceNewFileNamed: aPage filename! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
personalDetailsEncodings
	^ 'personalDetails'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 14:57'!
personalDetailsItemEncodings
	^ 'personalDetailsItem'! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBalise: aString

	stream nextPut: $<.
	stream nextPutAll: aString.
	stream nextPut: $>.
	stream nextPut: Character cr.

	! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 22:38'!
startBalise:  balise attribute: aKey value: aTag.
	
	stream 
		nextPut: $<; 
		nextPutAll: balise ; 
		nextPut: Character space ; 
		nextPutAll: aKey ; 
		nextPutAll: '="' ; 
		nextPutAll: aTag; 
		nextPutAll: '">'.! !

!KZVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBody

	self startBalise: 'body'.! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
tocEncodings
	^ 'toc'! !

!KZVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
tocItemEncodings
	^ 'tocItem'! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:47'!
visit: anElement

	anElement accept: self! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/18/2012 21:36'!
visitBibItemCollection: aBibItemCollection
	
	self ensureTag: 'ol' for: [:aStream | 
		KZBibHTMLOutputer  new 
			treatEntries: aBibItemCollection elements in: aStream]
		! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
visitDivBlock: aBlock

	self
		ensureIdValue: self mainContentEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 14:39'!
visitImage: aLinkedImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<img src="'; nextPutAll: aLinkedImage image; 
				nextPutAll: '">' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 22:51'!
visitItem: anItem

	self ensureTag: 'li' for: [:aStream | aStream nextPutAll: '<a href="', anItem link, '">', anItem name].
	stream cr.! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 22:39'!
visitItemList: aList

	self ensureAttribute: 'class'
			 value: 'itemizedlist'
			 div: [
				self ensureTag: 'ul' for: 
					[ :aStream | aList elements do: [:each | self visit: each ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 09:51'!
visitLinkedImage: anImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<a href="'; 
				nextPutAll: anImage link; 
				nextPutAll: '"><img src="'; nextPutAll: anImage image; 
				nextPutAll: '"></a>' ; 
				nextPut: Character cr]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 16:53'!
visitMenu: aMenu
	self
		ensureIdValue: self menuEncodings
		div: [ 
			self
				ensureIdValue: self tocEncodings
				div: [ aMenu elements do: [ :each | self visit: each ] 
										separatedBy: [ stream cr ] ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:11'!
visitMenuItem: aMenuItem
	self ensureIdValue: self tocItemEncodings div: [ self href: aMenuItem link name: aMenuItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/8/2012 21:26'!
visitPage: aPage
	
	[stream := self newFileFor: aPage.
	stream nextPutAll: aPage metaHead.
	stream nextPutAll: aPage head.
	self
		ensureBody: [ 
			self
				ensureIdValue: self headerEncodings
				div: [ 
					self ensureIdValue: self headerSideTitleEncodings div: [ stream nextPutAll: aPage headerSiteTitle ].
					self ensureIdValue: self headerPageTitleEncodings div: [ stream nextPutAll: aPage headerPageTitle ]].
			aPage elements do: [ :each | self visit: each ].
			self ensureIdValue: self mainContentEncodings div: [ 
					aPage main elements do: [ :each | self visit: each ]]			
			]]
		ensure: [stream close]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlock: aBlock
	self
		ensureIdValue: self personalDetailsEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!KZVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlockItem: anItem
	self ensureIdValue: self personalDetailsItemEncodings div: [ self href: anItem link name: anItem name ]! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 20:55'!
visitSection: aSection

	stream nextPutAll:  '<h', aSection levelDigitString,'><b><a NAME="', aSection title, '">',  aSection title, '</a></b></h', aSection levelDigitString,'>'.
	stream nextPutAll:  aSection text.! !

!KZVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 22:15'!
visitSite: aSite

	aSite pages do: [:each | self visit: each].! !

!String methodsFor: '*kozen' stamp: 'StephaneDucasse 1/6/2012 15:31'!
deDoubleSingleQuotes
	"transform two subsequent single quotes into one"
	
	"'abcdebcdg' . 'bc' .'z' ->  'azdezdg' but the same with '' and '"
	
	^ self copyReplaceAll: (String with: $' with: $')  with: (String with: $') 
	! !
StefSite initialize!
